﻿# -*- coding: utf-8 -*-
import urllib, urlparse
import re, json
from HTMLParser import HTMLParser

def httpget(url):
	try:
		file = urllib.urlopen(url)
		content = file.read()
		file.close()
		return content
	except:
		print url
		print 'captured'
		return False

def playlist(url):
	content = httpget(url)
	if content == False:
		return [False, 'youtube 200']
	items = []
	m = re.findall('<a class="pl-video-title-link[^"]*?"[^>]*?href="([^"]*?)"[^>]*?>\s*(.*?)\s*</a>', content, re.DOTALL)
	for e in m:
		title = HTMLParser().unescape(e[1].decode('utf-8')).encode('utf-8')
		items.append([title, 'https://www.youtube.com' + e[0], True])
	m = re.search('<button\s+.*?class="[^"]*?browse-items-load-more-button[^"]*?".*?href="(.*?)".*?>.*?</button>', content, re.DOTALL)
	if m:
		items.append(['Load more', 'https://www.youtube.com' + m.group(1), True])
	return [items]

def loadmore(url):
	content = httpget(url)
	if content == False:
		return [False, 'youtube 300']
	try:
		data = json.loads(content)
	except:
		return [False, 'youtube 301']
	items = []
	m = re.findall('<h3 class="yt-lockup-title">(.*?)</h3>', data['content_html'], re.DOTALL)
	for e in m:
		m1 = re.search('<a\s+.*?title="([^"]*?)".*?href="([^"]*?)".*?>.*?</a>', e, re.DOTALL)
		if m1 == None:
			continue
		title = m1.group(1)
		items.append([title, 'https://www.youtube.com' + m1.group(2), True])
	m = re.findall('<a class="pl-video-title-link[^"]*?"[^>]*?href="([^"]*?)"[^>]*?>\s*(.*?)\s*</a>', data['content_html'], re.DOTALL)
	for e in m:
		title = e[1]
		title = HTMLParser().unescape(title).encode('utf-8')
		items.append([title, 'https://www.youtube.com' + e[0], True])
	m = re.search('<button\s+.*?class="[^"]*?browse-items-load-more-button[^"]*?".*?href="(.*?)".*?>.*?</button>', data['load_more_widget_html'], re.DOTALL)
	if m:
		items.append(['Load more', 'https://www.youtube.com' + m.group(1), True])
	return [items]

def uservideos(url):
	content = httpget(url)
	if content == False:
		return [False, 'youtube 400']
	items = []
	m = re.findall('<h3 class="yt-lockup-title">(.*?)</h3>', content, re.DOTALL)
	for e in m:
		m1 = re.search('<a\s+.*?href="([^"]*?)".*?>(.*?)</a>', e, re.DOTALL)
		if m1 == None:
			continue
		title = HTMLParser().unescape(m1.group(2).decode('utf-8')).encode('utf-8')
		items.append([title, 'https://www.youtube.com' + m1.group(1), True])
	m = re.search('<button\s+.*?class="[^"]*?browse-items-load-more-button[^"]*?".*?href="(.*?)".*?>.*?</button>', content, re.DOTALL)
	if m:
		items.append(['Load more', 'https://www.youtube.com' + m.group(1), True])
	return [items]

def userplaylists(url):
	content = httpget(url)
	if content == False:
		return [False, 'youtube 500']
	items = []
	m = re.findall('<h3 class="yt-lockup-title">(.*?)</h3>', content, re.DOTALL)
	for e in m:
		m1 = re.search('<a\s+.*?href="([^"]*?)".*?>(.*?)</a>', e, re.DOTALL)
		if m1 == None:
			continue
		title = HTMLParser().unescape(m1.group(2).decode('utf-8')).encode('utf-8')
		items.append([title, 'https://www.youtube.com' + m1.group(1), True])
	m = re.search('<button\s+.*?class="[^"]*?browse-items-load-more-button[^"]*?".*?href="(.*?)".*?>.*?</button>', content, re.DOTALL)
	if m:
		items.append(['Load more', 'https://www.youtube.com' + m.group(1), True])
	return [items]

def user(url):
	items = []
	items.append(['videos', url + '/videos', True])
	items.append(['playlists', url + '/playlists?view=1', True])
	return [items]

def play1(url):
	try:
		para = urlparse.parse_qs(urlparse.urlparse(url).query)
		url = 'http://www.youtube.com/get_video_info?video_id=' + para['v'][0] + '&el=detailpage'
	except:
		return {'success': False, 'code':'youtube 100'}
	content = httpget(url)
	if content == False:
		return {'success': False, 'code':'youtube 101'}
	para = urlparse.parse_qs(content)
	try:
		title = para['title'][0]
		content = para['url_encoded_fmt_stream_map'][0]
	except:
		'''try:
			title = para['title'][0]
		except:
			return [False, 'youtube 102']
		url = para['hlsvp'][0]
		content = httpget(url)
		for line in re.split('\n', content):
			if len(line) == 0:
				continue
			if line[0] == '#':
				title = line
			else:
				item(title, line, False)'''
		return {'success': False, 'code':'youtube 102'}
	result = {'success': True, 'title': '', 'url': {}}
	contents = content.split(',')
	for content in contents:
		para = urlparse.parse_qs(content)
		result['url'][para['type'][0]] = para['url'][0]
	return result

def play2(url):
	para = urlparse.parse_qs(urlparse.urlparse(url).query)
	try:
		url = 'https://www.youtube.com/watch?v=' + para['v'][0]
	except LookupError:
		print para
		xbmcgui.Dialog().ok('错误', '错误500')
		return
	content = httpget(url)
	if content == False:
		xbmcgui.Dialog().ok('错误', '错误501')
		return
	content = re.search('"adaptive_fmts":"(.*?)"', content, re.DOTALL)
	if content == None:
		xbmcgui.Dialog().ok('错误', '错误502')
		return
	content = content.group(1)
	content = '{"adaptive_fmts":"' + content + '"}'
	data = json.loads(content)
	content = data['adaptive_fmts']
	content = 'http://www.test.com/?' + content
	para = urlparse.parse_qs(urlparse.urlparse(content).query)
	print len(para['type'])
	print len(para['bitrate'])
	print len(para['url'])
	i = 0
	for type in para['type']:
		item(type + ' ' + para['bitrate'][i], para['url'][i], False)
		i = i + 1
	xbmcplugin.endOfDirectory(handle)
